#include "lib.h"

Reference table_cell(Reference addr, size_t index)
// Returns a reference to the cell at the specified index.
//
{
    Reference result {0};
    Type::Table& table = *reinterpret_cast<Type::Table*>(addr.address);
    size_t inner = type_inner(addr.type);
    size_t offset = type_size(inner);

    // validate for overflow
    if(table.data.data != nullptr && offset > 0 && index < list.data.capacity) {
        result.type = inner;
        result.address = rawlist_cell(list.data, offset, index);
    }

    return result;
}


extern "C" size_t table_length(Reference addr)
{
    Type::Table& table = *reinterpret_cast<Type::Table*>(addr.address);
    return rawlist_length(table.data);
}

extern "C" void table_resize(Reference addr, size_t size)
{

}

extern "C" void table_clear(Reference addr)
{

}

extern "C" void table_set(Reference addr, size_t index, Reference data)
{

}

extern "C" void table_unset(Reference addr, size_t index)
{

}

extern "C" Reference table_get(Reference addr, size_t index)
{

}

extern "C" size_t table_next(Reference addr)
{

}
