#include "lib.h"

extern "C" Reference var_get(Reference addr)
// Returns the inner reference.
//
{
    Reference result {0};
    result = *reinterpret_cast<Reference*>(addr.address);
    return refr_make_temporary(result);
}

extern "C" void var_set(Reference addr, Reference source)
// Sets the inner reference.
//
{
    Reference& var = *reinterpret_cast<Reference*>(addr.address);
    
    if(var.address != nullptr) {
        drop(var);
    }

    if(var.type != source.type || var.address == nullptr) {
        if(var.address != nullptr) {
            free(var.address);
        }
        var.type = source.type;
        var.address = allocate(source.type, 1);
    }

    copy(var, source);
}
