Reference list_cell(Reference addr, size_t index);

extern "C" size_t list_capacity(Reference addr);
extern "C" size_t list_length(Reference addr);
extern "C" Reference list_at(Reference addr, size_t index);
extern "C" Reference list_front(Reference addr);
extern "C" Reference list_back(Reference addr);
extern "C" void list_clear(Reference addr);
extern "C" void list_insert(Reference addr, size_t index, Reference source);
extern "C" void list_push(Reference addr, Reference source);
extern "C" void list_pop(Reference addr);
extern "C" void list_set(Reference addr, size_t index, Reference source);
extern "C" void list_remove(Reference addr, size_t index);
extern "C" void list_reserve(Reference addr, size_t capacity);

//pub fn list_resize(addr:Ref, length:usize);
//pub fn list_cut(addr:Ref, index:usize, length:usize) -> Ref;
//pub fn list_find(addr:Ref, target:Ref, start:usize) -> usize;
//pub fn list_count(addr:Ref, target:Ref, start:usize) -> usize;
//pub fn list_truncate(addr:Ref, maximum:usize);
//pub fn list_shift(addr:Ref, maximum:usize);
