#include "lib.h"

size_t block_length(Reference addr)
// Returns the data length of the block.
//
{
    return type_innerkey(addr.type);
}


extern "C" uint8_t block_get(Reference addr, size_t index)
// Returns one byte of data from the specified index.
//
{
    if(index < block_length(addr)) {
        return reinterpret_cast<uint8_t*>(addr.address)[index];
    }
    return 0;
}

extern "C" void block_set(Reference addr, size_t index, uint8_t value)
// Sets one byte of data at the specified index.
//
{
    if(index < block_length(addr)) {
        reinterpret_cast<uint8_t*>(addr.address)[index] = value;
    }
}

extern "C" size_t block_get_bits(Reference addr, size_t index, size_t length)
{
    size_t result = 0;
    size_t byte_index = index >> 3;
    if(byte_index < block_length(addr)) {

    }
    return result;
}

extern "C" void block_set_bits(Reference addr, size_t index, size_t length, size_t data)
{
    size_t byte_index = index >> 3;
    if(byte_index < block_length(addr)) {

    }
}

/*extern "C" uint64_t block_get_natural(Reference addr)
{
    size_t length = type_innerkey(addr.type);
    uint8_t* data = reinterpret_cast<uint8_t*>(addr.address);
    uint64_t result = 0;

    for(size_t i = 0; i < length; ++i) {
        result |= data[i] << (8 * i);
    }

    return result;
}*/

/*extern "C" int64_t block_get_integer(Reference addr)
{
    size_t length = type_innerkey(addr.type);
    uint8_t* data = reinterpret_cast<uint8_t*>(addr.address);
    int64_t result = 0;

    for(size_t i = 0; i < length; ++i) {
        result |= data[i] << (8 * i);
    }

    return result;
}*/

/*extern "C" uint64_t block_get_field(Reference addr, size_t index, size_t length)
{
    size_t data_length = type_innerkey(addr.type);
    size_t byte_start = index >> 3;
    size_t bit_offset = index & 0x07;
    size_t byte_length = 1 + ((bit_offset + length) >> 3);
    size_t byte_end = byte_start + byte_length;
    size_t mask_offset = ((8 * byte_length) - (length + bit_offset));

    uint64_t mask = ((1 << length) - 1) << mask_offset;
    uint64_t bits = 0;

    uint8_t* data = reinterpret_cast<uint8_t*>(addr.address);

    size_t i = byte_start;
    for(; i < data_length && i < byte_end; ++i) {
        bits <<= 8;
        bits |= data[i];
    }
    for(; i < byte_end; ++i) {
        bits <<= 8;
    }

    return (bits & mask) >> mask_offset;
}*/

/*extern "C" void block_set_natural(Reference addr, uint64_t data)
{
    size_t length = type_innerkey(addr.type);
    uint8_t* dest = reinterpret_cast<uint8_t*>(addr.address);

    for(size_t i = 0; i < length; ++i) {
        dest[i] = (data >> (i * 8)) & 0xFF;
    }
}*/

/*extern "C" void block_set_integer(Reference addr, int64_t data)
{
    size_t length = type_innerkey(addr.type);
    uint8_t* dest = reinterpret_cast<uint8_t*>(addr.address);

    for(size_t i = length; i > 0; --i) {
        dest[i] = (data >> (i * 8)) & 0xFF;
    }
}*/

/*extern "C" void block_set_field(Reference addr, size_t index, size_t length, uint64_t value)
{
    size_t data_length = type_innerkey(addr.type);
    size_t byte_start = index >> 3;
    size_t bit_offset = index & 0x07;
    size_t byte_length = 1 + ((bit_offset + length) >> 3);
    size_t byte_end = byte_start + byte_length;
    size_t mask_offset = ((8 * byte_length) - (length + bit_offset));

    uint64_t mask = ((1 << length) - 1) << mask_offset;
    uint64_t bits = 0;

    uint8_t* data = reinterpret_cast<uint8_t*>(addr.address);

    size_t byte_index = byte_start;
    for(; byte_index < data_length && byte_index < byte_end; ++byte_index) {
        bits <<= 8;
        bits |= data[byte_index];
    }
    for(; byte_index < byte_end; ++byte_index) {
        bits <<= 8;
    }

    bits &= ~mask;
    bits |= mask & (value << mask_offset);

    for(; byte_index > data_length; --byte_index) {
        bits >>= 8;
    }
    for(; byte_index > byte_start; --byte_index) {
        data[byte_index - 1] = bits & 0xFF;
        bits >>= 8;
    }
}*/
