use crate::*;

#[test]
fn integer_initialize()
{
    let value = Integer::new();
    assert_eq!(0, value.get(), "Integer::new() produces value of 0.");
}

#[test]
fn integer_set_get()
{
    let mut value = Integer::new();
    value.set(-273);
    assert_eq!(-273, value.get(), "Integer.set(-273) produces value of -273.");
    value.set(100);
    assert_eq!(100, value.get(), "Integer.set(100) produces value of 100.");
}
